<?php

session_start();
chdir("..");

include "./includes/variables.php";
include "./misc/database.php";
include "password_func.php";
include '/usr/fallback/beroConf.php';

$ba = new beroAri();
require_once("./includes/lang.php");

# pages to redirect
$redir_index	= "/app/berogui/index.php";
$redir_login	= "/app/berogui/includes/login.php";

# get redirection URL
if (isset($_GET['m'])) {
	$open_parm = 'm=' . $_GET['m'];
} elseif (isset($_GET['userapp'])) {
	$open_parm = 'userapp=' . $_GET['userapp'];
}

# check if user and password are set
if ((strlen(trim($HTTP_POST_VARS['user'])) == 0) || (strlen((trim($HTTP_POST_VARS['password']))) == 0)) {
	header('Location:' . $redir_login . '?reason=cred_empty' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# extract username and password
$user		= htmlentities($HTTP_POST_VARS['user'], ENT_QUOTES);
$password	= $HTTP_POST_VARS['password'];

# check if user is in database
$result = $ba->select('SELECT * FROM users where user=\'' . $user . '\'');
if (!($row = $ba->fetch_array($result))) {
	header('Location:' . $redir_login . '?reason=cred_user' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# check if password is valid
if(!tep_validate_password($password, $row['password'])) {
	header('Location:' . $redir_login . '?reason=cred_pass' . ((!empty($open_parm)) ? '&' . $open_parm : ''));
	exit();
}

# set session-parameters
$_SESSION['beroari_username']	= $row['user'];
$_SESSION['beroari_group']	= $row['group_'];
$_SESSION['beroari_time']	= time();

# check if group is 'users' (and open not existing module 'callsf'...)
if ($row['group_'] == 'users') {
	header("Location:" . $redir_index . "?m=callsf");
	exit();
}

# open root db, check if ari.db has to be created or if we can read from it
$bc		= new beroConf('root');
$result		= $ba->select("SELECT vnum FROM version");
$versionen	= file("/usr/local/www/berogui/includes/versionen.php");

# settings for both cases (table exists or not)
$sql		= '';
$version	= '';

if ($result != false) {						// Die Tabelle version exisitiert in der Datenbank.
	$row		= $ba->fetch_array($result);
	$show		= false;
}

foreach ($versionen as $zeile) {

	if ($result != false) {					// Die Tabelle version exisitiert in der Datenbank.
		// Wenn die Versionsnummer übereinstimmt mit der Versionsnummer der Datei, werden die SQL Statements ab dieser Zeile gespeichert
		if ($show && (strpos($zeile, "VERSION") === false)) {
			$sql		.= $zeile;
		}

		if (strpos($zeile, "VERSION") !== false) {
			$values		= split(' ',$zeile);
			$values[1]	= trim($values[1]);
			$version	= $values[1];

			if ($values[1] == $row['vnum']) {
				$show = true;
			}
		}
	} else {						// Die Tabelle version exisitiert nicht in der Datenbank.
		if (strpos($zeile, "VERSION") === false) {
			$sql		.= $zeile;
		} else {
			$values		= split(' ',$zeile);
			$values[1]	= trim($values[1]);
			$version	= $values[1];
		}

	}

	if ((($result != false) && ($show == true) || ($result == false)) && ($version == 13)){
		$query = $ba->select('SELECT * from dialplan ORDER BY id');

		while ($entry = $ba->fetch_array($query)) {

			if ($entry['isdnid']!="" && !in_array($entry['isdnid'],$misdnids)) {
				array_push($misdnids,$entry['isdnid']);
				$q = $ba->select("select fromId, dest, src, id, newDest, newSrc from dialplan " .
							"where isdnid='" . $entry['isdnid'] . "' and direction='isdn-sip'");
				$en = $ba->fetch_array($q);

				$q1 = $ba->select("select toId, dest, src, id, newDest, newSrc from dialplan " .
								"where isdnid='".$entry['isdnid']."' and direction='sip-isdn'");
				$en1 = $ba->fetch_array($q1);

				$ba->update("UPDATE dialplan set newDest='" . $entry['isdnid'] . $en1['newDest'] . "', newSrc='".$en1['newSrc'] .
								"' WHERE id='".$en['id']."'");

				$ba->update("UPDATE dialplan set newDest='\\\\1', newSrc='\\\\1' WHERE id ='". $en1['id']."'");
			}
		}
		$version = 14;
	}
}

# echo $sql
$sql = trim($sql);
if (strlen($sql) > 0) {
	$ba->exec_query($sql);
}
$ba->exec_query("UPDATE version SET vnum='" . $version . "'");

// Datenbank Überprüfung ob ISDN/Analog Daten gespeichert sind (wenn nicht, werden die Line Interfaces gelesen).
$query_isdn	= $ba->select("select lif, type from isdn group by lif");
$query_analog	= $ba->select("select lif, type from analog group by lif");
$query_gsm	= $ba->select("select lif, type from gsm group by lif");
$query_cas	= $ba->select("select lif, type from cas group by lif");

if ((sqlite_num_rows($query_isdn) == 0) && (sqlite_num_rows($query_analog) == 0) && (sqlite_num_rows($query_gsm) == 0) && (sqlite_num_rows($query_cas) == 0)) {

	$ba = new beroAri();
	$ba->add_modules_db();
	$ba->enable_portswitch();

	if ($ba->is_error()){
		echo '<script>alert(' . $ba->error() . ');</script>';
	}


}

# open berogui
header('Location:' . $redir_index . ((!empty($open_parm)) ? '?' . $open_parm : ''));
?>
