<?php
/**
 * Klasse Sip_general
 * Zeigt allgemeine sip Einstellungen
 */

class Sip_general {
	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		// args
		$m = $_GET['m'];


		// build page content
		include('./includes/header.php');
		$sip_general_table = $this->dynamic_table();
                
		$ret .= "<form class='extensions_form' name='sip_general' id='sip_general' action='' method='POST' ENCTYPE=\"multipart/form-data\">
					<input type=hidden name=m value='" . $m . "'>
					<input type=hidden name=a value='save'>
					<br>
					<div id='content'>
						" . $sip_general_table . "
					</div>";
                $ret.='<script>$("#sip_general").validate({

                    rules: {
                            bindport: {
                                digits: true,
                                range: [1,65535],
                            },
                            udpports: {
                                rtpFormat : true,
                                rtpBindCheck : true,
                                rtpCount : true,
                            }
                    }
                }); </script>';

		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}



	/*
	 * Der Bind Port, der in der Datenbank gespeichert ist wird zurückgegeben
	 * und nachher angezeigt.
	 */
	function bind_port() {
		$ba = new beroAri();
		$query = $ba->select("select bindport from sip_general");
		while ($entry = $ba->fetch_array($query)) {
			$ret = $entry['bindport'];
			return $ret;
		}
	}

	/*
	 * Die Udpports, die in der Datenbank gespeichert sind werden zurückgegeben
	 * und nachher angezeigt.
	 */

	function udpports() {
		$ba = new beroAri();
		$query = $ba->select("select udpports from sip_general");
		while ($entry = $ba->fetch_array($query)) {
			return $entry['udpports'];
		}
	}


	/*
	 * Regrefresh wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 60 als default zurückgegeben
	 */
	function regrefresh(){
		$ba=new beroAri();
		if ($ba->get('regrefresh')!="")	return $ba->get('regrefresh');
		else return 60;
	}

	/*
	 * tos_sip (IP type of service for SIP traffic) wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 160 als default zurückgegeben
	 */
	function tos_sip(){
		$ba=new beroAri();
		if ($ba->get('tos_sip')!="")	return $ba->get('tos_sip');
		else return 160;
	}

	/*
	 * tos_rtp (IP type of service for RTP traffic) wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 160 als default zurückgegeben
	 */
	function tos_rtp(){
		$ba=new beroAri();
		if ($ba->get('tos_rtp')!="")	return $ba->get('tos_rtp');
		else return 160;
	}

	/*
	 * SSL_VERSION select box wird, mit den in der Datenbank gespeicherten Daten, erzeugt
	 * und angezeigt.
	 */
	function ssl_version(){
		$ba = new beroAri();
		$option=$ba->get("ssl_version");
		$sel="<select name='ssl_version'>";
		if ($option=="tls") $sel.="<option value='tls' selected>tls</option>";
		else $sel.="<option value='tls'>tls</option>";
                if ($option=="sslv2") $sel.="<option value='sslv2' selected>sslv2</option>";
		else $sel.="<option value='sslv2'>sslv2</option>";
		$sel.="</select>";
		return $sel;
	}

	
	/*
	 * reject_calls_under_load checkbox wird, mit den in der Datenbank gespeicherten Daten erzeugt
	 */
	function reject_calls_under_load(){
		$ba = new beroAri();
		$option=$ba->get("reject_calls_under_load");
		if ($option=="1") return "<input type='hidden' name='reject_calls_under_load' value='0'><input type='checkbox' name='reject_calls_under_load' value='1' checked>";
		else return "<input type='hidden' name='reject_calls_under_load' value='0'><input type='checkbox' name='reject_calls_under_load' value='1'>";
	}

	/*
	 * sip_transport checkboxes werden angezeigt.
	 */
	function sip_transport(){
		$ba = new beroAri();
		$options=$ba->get("sip_transport");
                $option=  explode(":", $options);
                
		if (in_array("tls", $option)) $sel.="<input type='checkbox' name='sip_transport[]' value='tls' id='sipt_tls' onclick='javascript:tls($(\"#sipt_tls\").prop(\"checked\"));'  checked>tls";
		else $sel.="<input type='checkbox' name='sip_transport[]' id='sipt_tls' onclick='javascript:tls($(\"#sipt_tls\").prop(\"checked\"));' value='tls'>tls";
                if (in_array("tcp", $option)) $sel.="<input type='checkbox' name='sip_transport[]' value='tcp' checked>tcp";
		else $sel.="<input type='checkbox' name='sip_transport[]' value='tcp'>tcp";
                if (in_array("udp", $option)) $sel.="<input type='checkbox' name='sip_transport[]' value='udp' checked>udp";
		else $sel.="<input type='checkbox' name='sip_transport[]' value='udp'>udp";
		return $sel;
	}

	/*
	 *rtp_port_selection select box wird, mit den in der Datenbank gespeicherten Daten, erzeugt
	 * und angezeigt.
	 */
	function rtp_port_selection(){
		$ba = new beroAri();
		$option=$ba->get("rtp_port_selection");
		$options = array ("standard", "roundrobin");
		$ret='<select name="rtp_port_selection" id="rtp_port_selection">';
		for ($i=0;$i<count($options);$i++){
			if ($option==$options[$i]) $ret.='<option value="'.$options[$i].'" selected>'.$options[$i].'</option>';
			else $ret.='<option value="'.$options[$i].'">'.$options[$i].'</option>';
		}
		$ret .='</select>';

		return $ret;
	}


	/*
	 * Funktion dynamic_table
	 */

	function dynamic_table() {
		//Die geänderten Werte werden gespeichert
		$ba = new beroAri();

		require_once("./includes/lang.php");
			
		if (isset($_POST['bindport']) && isset($_POST['udpports'])) {

                    $file_name= $_FILES["uploadfile_cafile"]["name"];
		    $tmp_file= $_FILES["uploadfile_cafile"]["tmp_name"];
                    if($_FILES["uploadfile_cafile"]["name"]!=""){
			if($_FILES["uploadfile_cafile"]["size"]>50000) //50 kB
			{
				$table.="<div class='center'><font color='red'>".SIP_GENERAL_FILE_SIZE_DIS." (cafile.pem)</font></div>";
			}else{
				exec("/bin/cp ".$tmp_file." /usr/conf/cafile.pem");
				$table.="<div class='center'> <font color='red'>".SIP_GENERAL_UPLOAD_SUCCESS_DIS." (cafile.pem)</font></div>";
                                $table.=Helper::activate(2,true,'sipg',ACTIVATE);
                        }
                    }
                    $file_name= $_FILES["uploadfile_agent"]["name"];
		    $tmp_file= $_FILES["uploadfile_agent"]["tmp_name"];
                    if($_FILES["uploadfile_agent"]["name"]!=""){
			if($_FILES["uploadfile_agent"]["size"]>50000) //50 kB
			{
				$table.="<div class='center'><font color='red'>".SIP_GENERAL_FILE_SIZE_DIS." (agent.pem)</font></div>";
			}else{
				exec("/bin/cp ".$tmp_file." /usr/conf/agent.pem");
				$table.="<div class='center'> <font color='red'>".SIP_GENERAL_UPLOAD_SUCCESS_DIS." (agent.pem)</font></div>";
                                $table.=Helper::activate(2,true,'sipg',ACTIVATE);
                        }
                    }
                        
                        if (isset($_POST['sip_transport'])){
                            foreach ($_POST['sip_transport'] as $value){
                                $sip_transport.=$value.":";
                            }
                        }
                        $ba->set("sip_transport",sqlite_escape_string (trim($sip_transport,":")));
			if (isset($_POST['ssl_version'])) $ba->set("ssl_version",sqlite_escape_string ($_POST['ssl_version']));
			if (isset($_POST['tos_rtp'])) $ba->set("tos_rtp",sqlite_escape_string ($_POST['tos_rtp']));
			if (isset($_POST['tos_sip'])) $ba->set("tos_sip",sqlite_escape_string ($_POST['tos_sip']));
			if (isset($_POST['rtp_port_selection'])) $ba->set("rtp_port_selection",sqlite_escape_string ($_POST['rtp_port_selection']));
			if (isset($_POST['reject_calls_under_load'])) $ba->set("reject_calls_under_load",sqlite_escape_string ($_POST['reject_calls_under_load']));
			$query = $ba->update("update sip_general set udpports='".sqlite_escape_string ( $_POST['udpports']) . "', bindport='".sqlite_escape_string ( intval($_POST['bindport'])) . "'");
                        $table.=Helper::activate(2,true,'sipg',ACTIVATE);


		}
		$table.="<script>
			function tls(chk){
				if (chk!=true){
					document.getElementById('ssl_version').style.display='none';
					document.getElementById('upload_cafile').style.display='none';
					document.getElementById('upload_agent').style.display='none';
				}else{
					document.getElementById('ssl_version').style.display='';
					document.getElementById('upload_cafile').style.display='';
					document.getElementById('upload_agent').style.display='';
				}

			}
		</script>";
		$table .= "<table class='contenttoc' id='table' style='width:auto;'>
					<tr>
					<th colspan='2'>".SIP_GENERAL_TABLE_HEADER_DIS."</th>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_GENERAL_BINDPORT . "')\" onmouseout='UnTip()'>
					<td><b>".SIP_GENERAL_BIND_PORT_DIS.":</b></td>
					<td><input type='text' name='bindport' id='bindport' value='" . $this->bind_port() ."' ></td>
					</tr>
					<tr onmouseover=\"Tip('" . SIP_GENERAL_UDPPORTS . "')\" onmouseout='UnTip()'>
					<td><b>".SIP_GENERAL_RTP_PORT_RANGE_DIS.":</b></td>
					<td><input type='text' name='udpports' id='udpports' value='" . $this->udpports() ."' ></td>
                    </tr>
                    <tr onmouseover=\"Tip('" . SIP_GENERAL_TOS_RTP . "')\" onmouseout='UnTip()'>
                    <td><b>".SIP_GENERAL_TOS_RTP_DIS.":</b></td>
					<td><input type='text' name='tos_rtp' value='" . $this->tos_rtp() ."' ></td>
					</tr>
                    <tr onmouseover=\"Tip('" . SIP_GENERAL_TOS_SIP . "')\" onmouseout='UnTip()'>
                    <td><b>".SIP_GENERAL_TOS_SIP_DIS.":</b></td>
					<td><input type='text' name='tos_sip' value='" . $this->tos_sip() ."' ></td>
					</tr>
                    <td><b>".SIP_GENERAL_REJECT_CALLS_UNDER_LOAD_DIS.":</b></td>
					<td>". $this->reject_calls_under_load() ."</td>
					</tr>
					<tr>
					<td><b>".SIP_GENERAL_RTP_PORT_SELECTION_DIS.":</b></td>
					<td>".$this->rtp_port_selection()."</td>
					</tr>
					<tr>
					<td><b>".SIP_GENERAL_SIP_TRANSPORT_DIS.":</b></td>
					<td>".$this->sip_transport()."</td>
					</tr>


					<tr id='ssl_version'>
					<td><b>".SIP_GENERAL_SSL_VERSION_DIS.":</b></td>
					<td>".$this->ssl_version()."</td>
					</tr>";
					if (file_exists("/usr/conf/cafile.pem")){
			$table .= "<tr>
					<td><b>".SIP_GENERAL_UPLOAD_CERTIFICATE_DIS." (cafile.pem):</b></td>
					<td><input type='button' value='".SIP_GENERAL_DOWNLOAD_CERTIFICATE_DIS." (cafile.pem)' onclick=\" window.location.href='misc/files_download.php?option=certificate&file=cafile';\">&nbsp;&nbsp;
					<input type='button' value='".SIP_GENERAL_DELETE_CERTIFICATE_DIS."' onclick=\"javascript:if (confirm('".SIP_GENERAL_DELETE_CERTIFICATE_MESS_DIS."?')==true) window.location.href='misc/deletedatei.php?option=certificate&file=cafile';\"></td>
					</tr>";
				}
					if (file_exists("/usr/conf/agent.pem")){
			$table .= "<tr>
					<td><b>".SIP_GENERAL_UPLOAD_CERTIFICATE_DIS." (agent.pem):</b></td>
					<td><input type='button' value='".SIP_GENERAL_DOWNLOAD_CERTIFICATE_DIS." (agent.pem)' onclick=\" window.location.href='misc/files_download.php?option=certificate&file=agent';\">&nbsp;&nbsp;
					<input type='button' value='".SIP_GENERAL_DELETE_CERTIFICATE_DIS."' onclick=\"javascript:if (confirm('".SIP_GENERAL_DELETE_CERTIFICATE_MESS_DIS."?')==true) window.location.href='misc/deletedatei.php?option=certificate&file=agent';\"></td>
					</tr>";
				}

			$table .= "<tr id='upload_cafile' onmouseover=\"Tip('" . UPLOAD_CERTIFICATE . "')\" onmouseout='UnTip()'>
					<td><b>".SIP_GENERAL_UPLOAD_CERTIFICATE_DIS." (cafile.pem):</b></td>
					<td nowrap><input type='file' size='28' name='uploadfile_cafile'></td>
					</tr>
                                        <tr id='upload_agent' onmouseover=\"Tip('" . UPLOAD_CERTIFICATE . "')\" onmouseout='UnTip()'>
					<td><b>".SIP_GENERAL_UPLOAD_CERTIFICATE_DIS." (agent.pem):</b></td>
					<td nowrap><input type='file' size='28' name='uploadfile_agent'></td>
					</tr>
                                        </table>
                                           
					
					<div class='center'>
					<input name='submit' type='submit' value='".BUTTON_SAVE."' onmouseover=\"Tip('" . SIP_GENERAL_SAVE . "')\" onmouseout='UnTip()'>
					</div>
					</form>
					<script type='text/javascript'>tls($('#sipt_tls').prop('checked'));</script>";
		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
